#include "addserver.h"
#include "ui_addserver.h"
#include "ui_editservers.h"
#include "ui_loginwindow.h"

addServer::addServer(EditServers *parent) :
    QDialog(parent),
    ui(new Ui::addServer)
{
    ui->setupUi(this);
    myParent = parent;
}

addServer::~addServer()
{
    delete ui;
}

Server addServer::getServer()
{
    Server server;
    server.serverName = ui->serverName->text();
    server.serverAddress = ui->serverAddress->text();
    server.serverPort = ui->serverPort->text();
    server.username = ui->username->text();

    QString username = ui->username->text();
    QString password = ui->password->text();
    int usersPartsCount = username.length();
    double nb = qFloor(usersPartsCount/2);
    for(int i=0;i<nb;i++)
    {
        password = username.at(i)+password+username.at(usersPartsCount-i-1);
    }
    QByteArray hash = QCryptographicHash::hash(password.toUtf8(), QCryptographicHash::Sha1);
    password = hash.toHex();
    server.password = password;
    return server;
}

void addServer::on_pushButton_2_clicked()
{
    Server server = getServer();
    myParent->myParent->myparent->logins.append(server);

    QString name = ui->serverName->text();
    name.append(" (").append(ui->serverAddress->text()).append(")");
    myParent->getUi()->serverList->insertItem(myParent->getUi()->serverList->count(), name, QVariant(myParent->getUi()->serverList->count()));
    myParent->myParent->getUi()->server->insertItem(myParent->myParent->getUi()->server->count(), name, myParent->myParent->getUi()->server->count());
    myParent->myParent->myparent->networkHandler->endTestServer();
    this->close();
}


void addServer::on_testButton_clicked()
{
    Server server = getServer();
    myParent->myParent->myparent->networkHandler->setTestServer(server);
    connect(myParent->myParent->myparent->networkHandler, SIGNAL(ssocketConnected()), this, SLOT(socketConnected()));
}

void addServer::socketConnected()
{
    qDebug() << "Called";
    QMessageBox qmbox(QMessageBox::Information, tr("Connected"), tr("Minecraft GUI connected to this server with success."), QMessageBox::Ok, this, Qt::Dialog);
    qmbox.setIconPixmap(QPixmap(":/images/icones/server_connect"));
    qmbox.exec();
}
