#include "editservers.h"
#include "addserver.h"
#include "ui_editservers.h"

EditServers::EditServers(LoginWindow *parent) :
    QDialog(parent),
    ui(new Ui::EditServers)
{
    ui->setupUi(this);
    myParent = parent;

    int size = myParent->myparent->logins.size();
    for (int i=0; i<size;i++)
    {
	QString name = myParent->myparent->logins.at(i).serverName;
	name.append(" (").append(myParent->myparent->logins.at(i).serverAddress).append(")");

	ui->serverList->insertItem(i, name, QVariant(i));
    }

}

EditServers::~EditServers()
{
    int size = myParent->myparent->logins.size();
    myParent->settings->remove("logins");
    myParent->settings->beginWriteArray("logins");
    for(int i=0;i<size;i++)
    {
	myParent->settings->setArrayIndex(i);
	myParent->settings->setValue("serverName", myParent->myparent->logins.at(i).serverName);
	myParent->settings->setValue("serverAddress", myParent->myparent->logins.at(i).serverAddress);
	myParent->settings->setValue("serverPort", myParent->myparent->logins.at(i).serverPort);
	myParent->settings->setValue("username", myParent->myparent->logins.at(i).username);
	myParent->settings->setValue("password", myParent->myparent->logins.at(i).password);
    }
    myParent->settings->endArray();
    delete ui;
}

void EditServers::on_removeButton_clicked()
{
    QMessageBox qmbox(QMessageBox::Warning, tr("Remove server"), tr("Are you sure you want to remove this server?<br />This can't be undone."), QMessageBox::No, this, Qt::Dialog);
    qmbox.setIconPixmap(QPixmap(":/images/icones/server_delete"));
    QPushButton *yesButton = qmbox.addButton(QMessageBox::Yes);
    qmbox.exec();
    if(qmbox.clickedButton() != yesButton)
    {
	return;
    }

    int id = ui->serverList->currentIndex();
    myParent->myparent->logins.removeAt(id);
    ui->serverList->removeItem(id);
}

Ui::EditServers* EditServers::getUi()
{
        return ui;
}

void EditServers::on_newButton_clicked()
{
    addServer addServer(this);
    addServer.exec();
}
