#include <QApplication>
#include <QCoreApplication>
#include <mainwindow.h>
#include <loginwindow.h>

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);
    QCoreApplication::setOrganizationName("Minecraft_GUI");
    QCoreApplication::setApplicationName("Config");

    QSettings *settings = new QSettings(QSettings::UserScope, "Minecraft_GUI", "config");
    QString locale = settings->value("locale", "").toString();
    if(locale.isEmpty())
    {
        locale = QLocale::system().name().section('_', 0, 0);
    }
    QTranslator QtTranslator;
    QtTranslator.load(QString("qt_")+locale, QLibraryInfo::location(QLibraryInfo::TranslationsPath));
    app.installTranslator(&QtTranslator);
    QTranslator translator;
    translator.load(QString("mcgui_")+locale);
    app.installTranslator(&translator);

    MainWindow MainWindow;
    MainWindow.show();

    LoginWindow LoginWindow(&MainWindow);
    LoginWindow.exec();

    return app.exec();
}
