#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QApplication>
#include <QtNetwork>
#include <QMessageBox>
#include <QSettings>
#include <QGraphicsView>
#include <QDesktopServices>
#include <QProcess>
#include <QInputDialog>
#include "loginwindow.h"
#include "preferences.h"
#include "serverStruct.h"

class NetworkHandler;
class LoginWindow;
namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    double version;
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    QTcpSocket *socket;
    bool socketConnected;
    bool credentialsSent;
    QString serverID;
    NetworkHandler *networkHandler;
    Ui::MainWindow* getUi();
    QList<Server> logins;

private slots:
    void on_actionQuitter_triggered();
    void on_actionObtenir_de_l_aide_triggered();
    void on_action_propos_triggered();
    void on_action_propos_de_Qt_triggered();
    void on_send_clicked();
    void on_reloadButton_clicked();
    void on_stopButton_clicked();
    void ssocketConnected1();
    void socketCredentialsIncorrect1();
    void versionMismatch1(bool type);
    void on_actionConnect_triggered();
    void on_joinButton_clicked();

    void on_actionSettings_triggered();

private:
    Ui::MainWindow *ui;
    QProcess process;

signals:
	void versionMismatch(bool);
	void ssocketConnected();
	void socketCredentialsIncorrect();
};

#endif // MAINWINDOW_H
