#ifndef TESTTABWIDGET_H
#define TESTTABWIDGET_H
#include <QTabBar>
#include <QTabWidget>
#include <QSize>
#include <QPaintEvent>
#include <QColor>
#include <QStylePainter>

#include "testtabwidget.h"

class TestTabBar : public QTabBar
{
public:
    explicit TestTabBar(QWidget* parent=0) : QTabBar(parent)
    {
	setIconSize(QSize(48, 48));
    }

protected:
    QSize tabSizeHint(int) const
    {
	return QSize(80, 80);
    }
    void paintEvent(QPaintEvent *)
    {
	QStylePainter p(this);
	for (int index = 0; index < count(); index++)
        {
            QStyleOptionTabV3 tab;
	    initStyleOption(&tab, index);

	    QIcon tempIcon = tab.icon;
	    QString tempText = tab.text;
	    tab.icon = QIcon();
	    tab.text = QString();
            p.drawControl(QStyle::CE_TabBarTab, tab);
            QRect tabrect = tabRect(index);
            tabrect.adjust(0, 4, 0, -8);
            p.setPen(Qt::white);
            p.drawText(tabrect, Qt::AlignBottom | Qt::AlignHCenter, tempText );
            tempIcon.paint(&p, 15, tabrect.top(), tab.iconSize.width(), tab.iconSize.height(), Qt::AlignTop | Qt::AlignHCenter);
            this->setTabIcon(index, tempIcon );
            this->setTabText( index, tempText);
	}
    }
};

class TestTabWidget : public QTabWidget
{
public:
    explicit TestTabWidget(QWidget *parent = 0) : QTabWidget(parent)
    {
	setTabBar(new TestTabBar());
    }
};


#endif // TESTTABWIDGET_H
