package me.Mika56.McGui;

import java.net.MalformedURLException;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Logger;
import java.util.regex.Pattern;

import lib.PatPeter.SQLibrary.*;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;


public class McGui extends JavaPlugin
{
	static final String versionDesc = "Alpha 2";
	static final double versionNum = 0.2;
	static final String createTableConfig = "CREATE TABLE `config` (`config_name` varchar(20) NOT NULL, `config_value` text NOT NULL, PRIMARY KEY (`config_name`));";
	static final String insertTableConfig = "INSERT INTO `config` VALUES ('is_dev', 'true');";
	static final String createTableUsersMySQL = "CREATE TABLE `users` (`id` int(3) NOT NULL AUTO_INCREMENT, `pseudo` varchar(30) NOT NULL, `password` varchar(30) NOT NULL, `email` varchar(100) NOT NULL, `rank` int(2) NOT NULL, PRIMARY KEY (`id`)) AUTO_INCREMENT=1;";
	static final String createTableUsersSQLite = "CREATE TABLE `users` (`id` INTEGER PRIMARY KEY AUTOINCREMENT, `pseudo` TEXT NOT NULL, `password` TEXT NOT NULL, `email` varchar(100) NOT NULL, `rank` INTEGER NOT NULL);";
	static final String createTablePermsMySQL = "CREATE TABLE `ranks` (`id` int(3) NOT NULL AUTO_INCREMENT, `name` varchar(30) NOT NULL, `can_power` int(1) NOT NULL, PRIMARY KEY(`id`)) AUTO_INCREMENT=1;";
	static final String createTablePermsSQLite = "CREATE TABLE `ranks` (`id` INTEGER PRIMARY KEY AUTOINCREMENT, `name` TEXT NOT NULL, `can_power` INTEGER NOT NULL);";
	static final String insertRanks = "INSERT INTO `ranks` VALUES ('1', 'Administrator', '1');INSERT INTO `ranks` VALUES ('2', 'User', '0');";
	static final String insertUser = "INSERT INTO `users`(pseudo, password, email, rank) VALUES(?, ?, ?, 0);";
	static final String checkUserAccount = "SELECT COUNT(*) AS nb FROM users WHERE pseudo = ?";
	static final Pattern emailPattern = Pattern.compile(".+@.+\\.[a-z]+");//TODO fix regex
	
	public Logger log = Logger.getLogger("Minecraft");
	public SocketServer socketServer = null;
	private final McGuiPlayerListener playerListener = new McGuiPlayerListener(this);
	public MySQL MySQL;
	public SQLite SQLite;
	private boolean isMySQL = true;
	private boolean isDev = false;
	
	public ArrayList<String> basicInfos = new ArrayList<String>();
	
	public void onEnable()
	{
		getConfig().options().copyDefaults(true);
		this.log.info("[McGui] McGui version "+versionDesc+" enabled !");
		this.isMySQL = getConfig().getBoolean("db.useMySQL", false);
		if(this.isMySQL)
		{
			this.MySQL = new MySQL(this.log, "[McGui]", getConfig().getString("db.host"), getConfig().getString("db.port", "3306"), getConfig().getString("db.database"),  getConfig().getString("db.username"), getConfig().getString("db.password"));
			try
			{
				this.MySQL.open();
				if(!this.MySQL.checkConnection())
				{
					this.MySQL = null;
					this.log.severe("[McGUI][MySQL] Unable to connect to database !");
					this.onDisable();
				}
			} catch (MalformedURLException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else
		{
			this.SQLite = new SQLite(this.log, "[McGui]", "dababase", this.getDataFolder().getPath());
			this.SQLite.open();
			if(!this.SQLite.checkConnection())
			{
				this.SQLite = null;
				this.log.severe("[McGUI][SQLite] Unable to connect to database !");
				this.onDisable();
			}
		}
		
		ResultSet dev;
		String query = "SELECT config_value FROM config WHERE config_name = 'is_dev'";
		try
		{
			if(this.isMySQL)
			{
				if(!this.MySQL.checkTable("config"))
				{
					this.log.info("[McGUI][MySQL] Creating table config");
					this.MySQL.createTable(createTableConfig);
					this.MySQL.query(insertTableConfig);
				}
				if(!this.MySQL.checkTable("users"))
				{
					this.log.info("[McGUI][MySQL] Creating table users");
					this.MySQL.createTable(createTableUsersMySQL);
				}
				if(!this.MySQL.checkTable("ranks"))
				{
					this.log.info("[McGUI][MySQL] Creating table ranks");
					this.MySQL.createTable(createTablePermsMySQL);
					this.MySQL.query(insertRanks);
				}
				dev = this.MySQL.query(query);
			}
			else
			{
				if(!this.SQLite.checkTable("config"))
				{
					this.log.info("[McGUI][SQLite] Creating table config");
					this.SQLite.createTable(createTableConfig);
					this.SQLite.query(insertTableConfig);
				}
				if(!this.SQLite.checkTable("users"))
				{
					this.log.info("[McGUI][SQLite] Creating table users");
					this.SQLite.createTable(createTableUsersSQLite);
				}
				if(!this.SQLite.checkTable("ranks"))
				{
					this.log.info("[McGUI][SQLite] Creating table ranks");
					this.SQLite.createTable(createTablePermsSQLite);
					this.SQLite.query(insertRanks);
				}
				dev = this.SQLite.query(query);
			}
			if(dev != null && dev.next())
			{
				//getBoolean returns false when config_value = "true" when using SQLite !
				this.isDev = Boolean.parseBoolean(dev.getString("config_value"));
				if(this.isDev)
				{
					this.log.info("[McGui] Dev mode enabled");
				}
			}
		}
		catch(MalformedURLException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		PluginManager pm = this.getServer().getPluginManager();
		this.socketServer = new SocketServer(getConfig().getInt("server.port", 62484), this);
		pm.registerEvent(Event.Type.PLAYER_CHAT, playerListener, Event.Priority.Normal, this);
		pm.registerEvent(Event.Type.PLAYER_JOIN, playerListener, Event.Priority.Normal, this);
		pm.registerEvent(Event.Type.PLAYER_QUIT, playerListener, Event.Priority.Normal, this);
	}
	
	public void onDisable()
	{
		this.socketServer.stop();
		this.socketServer = null;
		if(this.isMySQL)
		{
			this.MySQL.close();
			this.MySQL = null;
		}
		else
		{
			this.SQLite.close();
			this.SQLite = null;
		}
		//this.saveConfig();
		this.log.info("[McGui] McGui version "+versionDesc+" disabled !");
	}
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
	{
		if(commandLabel.equalsIgnoreCase("gui"))
		{
			if(args.length > 0)
			{
				if(args[0].equalsIgnoreCase("help"))
				{
					if(args.length > 1)
					{
						if(args[1].equalsIgnoreCase("help"))
						{
							sender.sendMessage("You asked help on... help command !");
							sender.sendMessage("Do I really need to explain how it works ? :o");
							return true;
						}
						else if(args[1].equalsIgnoreCase("create"))
						{
							sender.sendMessage("Usage : /gui create <password> <email>");
							sender.sendMessage("Creates an account on Minecraft GUI.");
							sender.sendMessage("Replace <password> by the desired password and <email> by your email address.");
							return true;
						}
						else if(args[1].equalsIgnoreCase("lostpass"))
						{
							sender.sendMessage("Usage : /gui lostpass");
							sender.sendMessage("Sends you a new password to your email address");
							return true;
						}
					}
				}
				else if(args[0].equalsIgnoreCase("create"))
				{
					if(args.length == 3)
					{
						registerUser(sender, args[1], args[2]);
						return true;
					}
				}
			}
		}
		return false;
	}

	/**
	 * 
	 * @param sender
	 * @param pwd
	 * @param email
	 */
	private void registerUser(CommandSender sender, String pwd, String email)
	{
		Player player = (Player) sender;

		try
		{
			PreparedStatement selectStatement;
			if(this.isMySQL)
			{
				selectStatement = this.MySQL.prepare(checkUserAccount);
			}
			else
			{
				selectStatement = this.SQLite.prepare(checkUserAccount);
			}
			selectStatement.setString(1, player.getName());
			if(selectStatement.executeQuery().getInt(1)==1)
			{
				sender.sendMessage("An account is already registered with this pseudo.");
				sender.sendMessage("If you lost your password, please use the /gui lostpass command");
				return;
			}
			
			if(pwd.length() < 4)
			{
				sender.sendMessage("Password length must be at least 4 characters.");
				return;
			}
			if(!emailPattern.matcher(email).matches())
			{
				sender.sendMessage("Please provide a valid email address.");
				return;
			}
			String encodedPass = Utils.makePassword(player.getName(), pwd);
			PreparedStatement insertStatement = null;

			if(this.isMySQL)
			{
				insertStatement = this.MySQL.prepare(insertUser);
			}
			else
			{
				insertStatement = this.SQLite.prepare(insertUser);
			}
			if(insertStatement != null)
			{
				insertStatement.setString(1, player.getName());
				insertStatement.setString(2, encodedPass);
				insertStatement.setString(3, email);
				if(insertStatement.executeUpdate() == 1)
				{
					sender.sendMessage("Account created with success !");
				}
				else
				{
					sender.sendMessage("An error occured while trying to create your account.");
					sender.sendMessage("Please try again later.");
				}
				return;
			}
		} catch (SQLException e)
		{
			e.printStackTrace();
		}
		catch (MalformedURLException e)
		{
			e.printStackTrace();
		} catch (InstantiationException e)
		{
			e.printStackTrace();
		} catch (IllegalAccessException e)
		{
			e.printStackTrace();
		}
		sender.sendMessage("An error occured while trying to create your account. Please try again later.");
	}

	public boolean isDev()
	{
		return this.isDev;
	}
	public boolean isMySQL()
	{
		return this.isMySQL;
	}
}