package me.Mika56.McGui;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.URL;
import java.net.URLConnection;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.World.Environment;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.PluginManager;

abstract class Utils
{
	public static String makePassword(String username, String password)
	{
		int usersPartsCount = username.length();
		double nb = Math.floor(usersPartsCount/2);
		for(int i=0;i<nb;i++)
		{
			password = username.charAt(i)+password+username.charAt(usersPartsCount-i-1);
		}
		try
		{
			return sha1(password);
		} catch (NoSuchAlgorithmException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	public static String sha1(String password) throws NoSuchAlgorithmException
	{
		MessageDigest digest = MessageDigest.getInstance("SHA-1");
		digest.reset();
		byte[] input = null;
		try
		{
			input = digest.digest(password.getBytes("UTF-8"));
			StringBuffer hexString = new StringBuffer();
			for(int i=0;i<input.length;i++)
			{
				String hex = Integer.toHexString(0xFF & input[i]);
				if(hex.length() == 1)
				{
					hexString.append('0');
				}
				hexString.append(hex);
			}
			return hexString.toString();
		}
		catch(UnsupportedEncodingException e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getOS()
	{
		String os = System.getProperty("os.name").toLowerCase();
		if(os.indexOf("win") >= 0)
		{
			return "win";
		}
		else if(os.indexOf("mac") >= 0)
		{
			return "mac";
		}
		else if(os.indexOf("nix") >= 0 || os.indexOf("nux") >= 0)
		{
			return "linux";
		}
		else
		{
			return null;
		}
	}
	
	public static String implode(String delimiter, ArrayList<String> array)
	{
		String[] newArray = new String[array.size()];
		array.toArray(newArray);
		return implode(delimiter, newArray);
	}
	public static String implode(String delimiter, String[] array)
	{
		StringBuffer sb = new StringBuffer();
		int ArrayLength = array.length;
		for(int i=0; i<ArrayLength;i++)
		{
			if(i!=0 && i<ArrayLength)
				sb.append(delimiter);
			
			sb.append(array[i]);
		}
		return sb.toString();
	}
	
	public static String convertStreamToString(InputStream is) throws IOException
	{
		if(is!=null)
		{
			Writer writer = new StringWriter();
			
			char[] buffer = new char[1024];
			try
			{
				Reader reader = new BufferedReader(new InputStreamReader(is, "UTF-8"));
				int n;
				while((n = reader.read(buffer)) != -1)
				{
					writer.write(buffer, 0, n);
				}
			}
			finally
			{
				is.close();
			}
			return writer.toString();
		}
		else
		{
			return "";
		}
	}

	public static void getOsVersion(ArrayList<String> infos) throws IOException
	{
		String os = Utils.getOS();
		if(os == "win")
		{
			infos.add("Windows"); //OS Type
			Process pr = Runtime.getRuntime().exec("wmic os get Caption /Value");
			try
			{
				pr.waitFor();
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			BufferedReader buf = new BufferedReader(new InputStreamReader(pr.getInputStream()));
			String cmdLine = "";
			while((cmdLine=buf.readLine())!=null)
			{
				if(!cmdLine.isEmpty())
				{
					break;
				}
			}
			String OSVersion[] = cmdLine.split("=");
			infos.add(OSVersion[1]); //OS Version
		}
		else if(os == "linux")
		{
			//Detect
			infos.add("GNU/Linux");
			String OsDetect[] = {"/etc/debian_version", "/etc/gentoo-release"};
			int OsDetectLength = OsDetect.length;
			for(int i=0;i<OsDetectLength;i++)
			{
				File file = new File(OsDetect[i]);
				if(file.exists())
				{
					FileReader fr = new FileReader(file);
					String str = "";
					int fileI = 0;
					while((fileI=fr.read())!=-1)
					{
						str+= (char)fileI;
					}
					infos.add(str);
					break;
				}
			}
		}
		else if(os == "mac")
		{
			infos.add("Mac");
			infos.add(""); //OS Version
		}
		else
		{
			infos.add("?");
			infos.add("?"); //OS Version
		}
	}
	
	public static void getIp(ArrayList<String> infos) throws IOException
	{
		URL IPurl = new URL("http://www.whatismyip.org");
		URLConnection IPurlc = IPurl.openConnection();
		InputStream IPis =new BufferedInputStream(IPurlc.getInputStream());
		infos.add(Utils.convertStreamToString(IPis));
	}
	
	/**
	 * Adds system uptime to the ArrayList infos
	 * @param infos
	 * @throws IOException
	 * @TODO Seems to always return 9h05
	 */
	public static void getUptime(ArrayList<String> infos) throws IOException
	{
		String os = Utils.getOS();
		Date lastBoot = new Date();
		if(os == "win")
		{
			Process pr = Runtime.getRuntime().exec("wmic os get lastbootuptime /Value");
			try
			{
				pr.waitFor();
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			BufferedReader buf = new BufferedReader(new InputStreamReader(pr.getInputStream()));
			String cmdLine = "";
			while((cmdLine=buf.readLine())!=null)
			{
				if(!cmdLine.isEmpty())
				{
					break;
				}
			}
			String Uptime[] = cmdLine.split("=");
			Uptime = Uptime[1].split("\\.");
			SimpleDateFormat parser = new SimpleDateFormat("yyyyMMddHHmmss");
			try
			{
				lastBoot = parser.parse(Uptime[0]);
			} catch (ParseException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else if(os == "linux")
		{
			/*File file = new File("/proc/uptime");
			if(file.exists())
			{
				FileReader fr = new FileReader(file);
				String str = "";
				int fileI = 0;
				while((fileI=fr.read())!=-1)
				{
					str+= (char)fileI;
				}
				String[] parts = str.split(" ");
				secs = (int) Double.parseDouble(parts[0]);
				
			}*/
		}
		else if(os == "mac")
		{
		}
		else
		{
		}
		infos.add(lastBoot.toString());
	}

	public static int getWhitelistCount() throws IOException
	{
		File file = new File("white-list.txt");
		if(file.exists())
		{
			FileReader fr = new FileReader(file);
			String str = "";
			int fileI = 0;
			while((fileI=fr.read())!=-1)
			{
				str+= (char)fileI;
			}
			String[] parts = str.split("\n");
			return parts.length;			
		}
		return 0;
	}

	public static String getPlugins(Server serveur)
	{
		ArrayList<String> pluginsList = new ArrayList<String>();
		PluginDescriptionFile pdf;
		PluginManager pm = serveur.getPluginManager();
		Plugin[] plugins = pm.getPlugins();
		int pluginsCount = plugins.length;
		for(int i=0;i<pluginsCount;i++)
		{
			pdf = plugins[i].getDescription();
			pluginsList.add(pdf.getName());
		}
		return Utils.implode(", ", pluginsList);
	}

	public static long getHour(Server serveur)
	{
		List<World> worldsList = serveur.getWorlds();
		int nbWorlds = worldsList.size();
		for(int i=0;i<nbWorlds;i++)
		{
			if(worldsList.get(i).getEnvironment() == Environment.NORMAL)
				return worldsList.get(i).getTime();
		}
		return 0;
	}
}
