package me.Mika56.McGui;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.Socket;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

import org.bukkit.ChatColor;
import org.bukkit.Server;

public class WorkerRunnable implements Runnable
{
	protected Socket clientSocket = null;
	protected SocketServer server = null;
	protected int _numclient = 0;
	protected Thread _t;
	
	protected BufferedReader _in = null;
	protected DataOutputStream _out = null;
	
	protected boolean isTest = false;
	protected String username = null;
	protected String password = null;
	protected String email = null;
	protected String rank = null;
	protected ArrayList<String> rights = new ArrayList<String>();
	protected boolean isLogged = false;
	
	public WorkerRunnable(Socket clientSocket, SocketServer server) {
		try
		{
			this.clientSocket = clientSocket;
			this.server = server;
			
			this._in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
			this._out = new DataOutputStream(clientSocket.getOutputStream());
			this._numclient = server.addClient(this);
		}
		catch (IOException e)
		{
		}
		this._t = new Thread(this);
		_t.start();
	}
	
	public void run()
	{
		try
		{
			String line = "";
			if (this.server.plugin.isDev())
			{
				this.server.plugin.log.info("Connection of client No" + this._numclient);
			}
			while ((line = this._in.readLine()) != null)
			{
				if (this.server.plugin.isDev())
				{
					this.server.plugin.log.info("< " + line);
				}
				
				try
				{
					if (!this.isLogged)
					{
						if (line.startsWith("HELLO"))
						{
							if(line.endsWith("test"))
							{
								this.isTest = true;
							}
							sendPacket("HELLO " + McGui.versionNum);
						}
						else if (line.startsWith("USER") && this.username == null)
						{
							this.username = line.replace("USER ", "");
							sendPacket("100 Please send password");
						}
						else if (line.startsWith("PASS") && this.password == null)
						{
							this.password = line.replace("PASS ", "");
							try
							{
								PreparedStatement query;
								String querySQL = "SELECT email, rank FROM users WHERE pseudo = ? AND password = ? LIMIT 0, 1";
								if (this.server.plugin.isMySQL())
								{
									query = this.server.plugin.MySQL.prepare(querySQL);
								}
								else
								{
									query = this.server.plugin.SQLite.prepare(querySQL);
								}
								query.setString(1, this.username);
								query.setString(2, this.password);
								ResultSet result = query.executeQuery();
								if (result != null && result.next())
								{
									this.email = result.getString("email");
									this.rank = result.getString("rank");
									this.isLogged = true;
									sendPacket("200 Logged in");
									if(!this.isTest)
									{
										String queryRights = "SELECT can_power FROM ranks WHERE id = " + this.rank;
										ResultSet resultRights;
										if (this.server.plugin.isMySQL())
										{
											resultRights = this.server.plugin.MySQL.query(queryRights);
										}
										else
										{
											resultRights = this.server.plugin.SQLite.query(queryRights);
										}
										for (int i = 1; i <= 1; i++)
										{
											this.rights.add(resultRights.getString(i));
										}
										sendPacket("RIGHTS " + Utils.implode("|", this.rights));
										
										ArrayList<String> paquet = new ArrayList<String>();
										paquet.add(this.username);
										paquet.add("gui");
										this.server.sendAll("PLAYERJOIN " + Utils.implode("|", paquet));
										Server serveur = this.server.plugin.getServer();
										serveur.broadcastMessage(ChatColor.YELLOW + this.username + " joined from GUI.");
									}
								}
								else
								{
									this.isLogged = false;
									sendPacket("403 Username or password incorrect");
								}
							}
							catch (InstantiationException e)
							{
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							catch (IllegalAccessException e)
							{
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							catch (SQLException e)
							{
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
						else
						{
							sendPacket("400 Unknown command or not logged in");
						}
					}
					else
					{
						if (line.startsWith("BASICINFOS"))
						{
							sendBasicInfos();
						}
						else if (line.startsWith("SERVERINFOS"))
						{
							sendServerInfos();
						}
						else if (line.startsWith("CHAT"))
						{
							sendChat(line);
						}
						else if(line.startsWith("RELOAD"))
						{
							initReload();
						}
						else if(line.startsWith("STOP SERVER"))
						{
							initStop();
						}
						else
						{
							sendPacket("400 Unknown command");
						}
					}
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		}
		catch (IOException e)
		{
			try
			{
				clientSocket.close();
			}
			catch (IOException e1)
			{
			}
		}
		finally
		{
			if (this.server.plugin.isDev())
			{
				this.server.plugin.log.info("Client no" + this._numclient + " deconnected");
			}
			this.server.delClient(this._numclient);
			if (this.isLogged)
			{
				ArrayList<String> paquet = new ArrayList<String>();
				paquet.add(this.username);
				paquet.add("gui");
				this.server.sendAll("PLAYERQUITS " + Utils.implode("|", paquet));
				this.server.plugin.getServer().broadcastMessage(ChatColor.YELLOW + this.username + " left the GUI.");
			}
			try
			{
				this.clientSocket.close();
			}
			catch (IOException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	public String getName()
	{
		return this.username;
	}
	private void initStop()
	{
		if(this.rights.get(0).equals("1"))
		{
			this.server.plugin.getServer().shutdown();
		}
		else
		{
			sendPacket("403 command not allowed");
		}
	}

	private void initReload()
	{
		if(this.rights.get(0).equals("1"))
		{
			this.server.plugin.getServer().reload();
		}
		else
		{
			sendPacket("403 command not allowed");
		}
	}

	private void sendChat(String line)
	{
		String msg = line.substring(5);
		if(msg.isEmpty())
		{
			return;
		}
		ArrayList<String> paquet = new ArrayList<String>();
		paquet.add(this.username);
		paquet.add("gui");
		paquet.add(msg);
		this.server.sendAll("CHATMSG " + Utils.implode("|", paquet));
		
		Server serveur = this.server.plugin.getServer();
		serveur.broadcastMessage("<" + this.username + " (" + ChatColor.GRAY + "GUI" + ChatColor.WHITE + ")> " + paquet.get(2));
	}

	private void sendServerInfos() throws IOException
	{
		ArrayList<String> infos = new ArrayList<String>();
		Server serveur = this.server.plugin.getServer();
		infos.add("" + serveur.getPort());
		infos.add(serveur.getVersion());
		infos.add("" + serveur.getOnlinePlayers().length);
		infos.add("" + serveur.getMaxPlayers());
		infos.add("" + Utils.getWhitelistCount());
		infos.add(Utils.getPlugins(serveur));
		infos.add("" + Utils.getHour(serveur));
		
		sendPacket("SERVERINFOS " + Utils.implode("|", infos));
	}
	
	private void sendBasicInfos() throws IOException
	{
		if (this.server.plugin.basicInfos.isEmpty())
		{
			Utils.getOsVersion(this.server.plugin.basicInfos);
			Utils.getIp(this.server.plugin.basicInfos);
			Utils.getUptime(this.server.plugin.basicInfos);
		}
		sendPacket("BASICINFOS " + Utils.implode("|", this.server.plugin.basicInfos));
	}
	
	public void sendPacket(String paquet)
	{
		try
		{
			this.server.plugin.log.info("> " + paquet);
			paquet += "" + (char) 25 + (char) 26; // End of packet
			this._out.write(paquet.getBytes("UTF-8"));
			this._out.flush();
		}
		catch (UnsupportedEncodingException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
